// Header File
// Created 11/05/2003; 19:24:21

#ifndef GAME_H
#define GAME_H

#include "Mode7Engine.h"
#include "constants.h"
#include "track.h"
#include "menu.h"
#include "physicsconstants.h"
#include "physics.h"
#include "gameplay.h"
#include "kbd.h"
#include "hud.h"
#include "fastdigit.h"

// definitions
#define MAX_MACHINES 4
#define GHOSTFILE_SIGNATURE "FGHSTV02"
#define FZERO_VERSION 2
#define DATA_FILE_VERSION 0
#define GHOST_BUFFER_SIZE 10240

// typdefs
typedef struct masterp {
	unsigned char selected_machine;
	unsigned char balance;
	char gpnum;
	char tracknum;
	char nbcpu;
	char cpulvl;
} masterp;

typedef struct slavep {
	unsigned char selected_machine;
	unsigned char balance;
} slavep;

typedef struct ghostp {
	unsigned char selected_machine;
	unsigned char balance;
	unsigned short time;
	unsigned char * data;
} ghostp;

typedef struct record {
	unsigned char name[7];
	unsigned char machine;
	unsigned short time;
} record;

typedef struct save_struct {
	unsigned char inputname[6];
	unsigned char cpuplayers;
	unsigned char cpulevel;
	unsigned char linktype;
	unsigned char autoarchive;
	unsigned char grandprix;
	unsigned char class;
	record records[250];
	unsigned char gpcompleted[25];
	unsigned char staffghostunlocked[25];
} save_struct;

//file
extern ARCH * fzeropk0;
extern ARCH * fzeropk1;
extern ARCH * fzeropk2;
extern ARCH * fzerodt0;


//strings
extern const char * fstpath[];
extern const char * firepath[];
extern const char * scaledpath[];
extern const unsigned char * styles[];


//track & map
extern Track track;
extern char trackfilename[];
extern unsigned short nbfx;
extern unsigned char * effects;
extern ExtraMap * xm;
extern unsigned short * WPM;
extern const char selection[];
extern const char fill_with[];


//save
extern save_struct * save;


//menu
extern unsigned char mp[];
extern masterp mparam;
extern slavep sparam;
extern ghostp gparam;
extern slavep * player;
extern unsigned char ghostloaded;
extern unsigned char endRaceStatus;


//gameplay
extern Machine machines[MAX_MACHINES];
extern const unsigned short stats[4][7];
extern unsigned short Gravity;
extern unsigned char rank[MAX_MACHINES];
extern unsigned char sel_machines[MAX_MACHINES];
extern unsigned char sprites_id[MAX_MACHINES];
extern unsigned char balance_tab[MAX_MACHINES];
extern unsigned char controlled_tab[MAX_MACHINES];
extern unsigned char nb_machines;
extern unsigned char end_race_status; // 0 nothing, 1 dead, 2 finish, 3 pause
extern unsigned char lapbuff[];
extern volatile unsigned char HudChange, MapChange, EnergyChange, LapChange, RankChange;
extern volatile unsigned char revevent;
extern volatile unsigned char boostevent;


//HUD
extern unsigned char hudscreen[OFFSET_SKY_VERT*30];
extern unsigned char * Planes[4];


//ghosts
extern unsigned char * ghost_record_buffer;
extern unsigned char * ghost_record_buffer_current;
extern unsigned char hold;
extern volatile unsigned short ghost_record;

#endif
