// Header File
// Created 28/04/2005; 21:51:09

#ifndef GAMEPLAY_H
#define GAMEPLAY_H

#include "game.h"

typedef struct Machine {
	unsigned char id; // sprite id
	unsigned char controlled; // 0: PLAYER, 1: LINK, 2: GHOST, 3-7: CPU {NOVICE, STANDARD, EXPERT, MASTER, ULTIMATE}

// machine stats
	unsigned short weight; // weight of the machine
	unsigned short body; // number of energy lost at each collision
	unsigned short boost; // time of boost time
	unsigned short grip; // grip
	unsigned short accel; // acceleration (+ balance)
	unsigned short maxspeed; // max speed (+ balance)
	unsigned short cornering; // cornering

// machine status
	unsigned char energy;
	unsigned char attacked;
	unsigned short currentwp;
	unsigned short previouswp;
	unsigned char lapcount;
	unsigned char lapreverse;
	unsigned short totaltime;
	unsigned short currentlap;
	unsigned short bestlap;
	unsigned char rank;

// physics
	unsigned short thrust; // go in the direction of the sprite
	unsigned short altitude;
	unsigned short potential;
	unsigned short risespeed;
	unsigned short fallspeed;
	Vect extForce;
	Vect inertia;
	
// control
	short dirs[SLIDE_GRIP];
	unsigned char sliding;
	unsigned char boosting;
	signed   char turning;
	unsigned char doubleleft;
	unsigned char doubleright;
	unsigned char impulse;
	unsigned char shield;
	unsigned char accelerating;

// AI control
	unsigned char jumping;
	unsigned short boostperiod;
	unsigned short energyperiod;
		
// ghosts
	unsigned char hold;
	unsigned char * data;

} Machine;

void resetMachines(void);
void addMachines(void);
void computeRank(void);

void m_race_intro(void);
void d_animate_cpu(void);
void dummy(void);
void gameover(void);
void finish(void);

#endif
