// C Source File
// Created 02/08/2004; 22:25:41

#include "Mode7Engine.h"

ARCH * afopen (const char *filename) {
	SYM_ENTRY *sym;
	ARCH * arch;

	sym = SymFindPtr(filename,0);
	if(!sym) return NULL;
	if(!(sym->flags.bits.archived)) return NULL;
	arch = (ARCH*)Malloc(sizeof(ARCH));
	arch->apos=HeapDeref(sym->handle);
	arch->size = *(short *)(arch->apos);
	arch->set = arch->apos + 2;
	arch->apos += 2;
	
	return arch;
}

ARCH * aopen (ARCH * arch, const char * subfilename) {
	ARCH *a, *b;
	unsigned short i, j;
	unsigned char nbfile;
	unsigned char filename[9];
	unsigned short subdiroffset = 0;
	unsigned char subdir[9];
	char * apos;
	unsigned short filepos, filesize;

	a = (ARCH*)Malloc(sizeof(ARCH));
	for (i = 0; i < strlen (subfilename); i++) {
		if (subfilename[i] == '\\') {subdiroffset = i; break;}
	}
	
	if (i > 8) {
		Free (a);
		return NULL;
	}

	memcpy(subdir, subfilename, i);
	subdir[i] = 0;
	
	apos = arch->apos;
	aseek (arch, 0, SEEK_SET);
	aread (&nbfile, sizeof(unsigned char), 1, arch);
	
	for (i = 0; i < nbfile; i++) {
		aread (&filepos, sizeof(unsigned short), 1, arch);
		aread (&filesize, sizeof(unsigned short), 1, arch);
		for(j = 0; j < 8; j++) {
			aread (&(filename[j]), sizeof(unsigned char), 1, arch);
			if (filename[j] == 0)
				break;
		}
		if (j == 8)
			aseek (arch, 1, SEEK_CUR);

		filename[j] = 0;
		if (strcmp (filename, subdir) == 0) {
			a->apos = arch->set + filepos;
			a->set = filepos + arch->set;
			a->size = filesize;
			arch->apos = apos;
			if (subdiroffset) {
				b = aopen (a, subfilename + subdiroffset + 1);
				Free (a);
				a = b;
			}
			return a;
		}
	}
	arch->apos = apos;
	Free (a);
	return NULL;
}

void aclose (ARCH * arch) {
	Free (arch);
}

unsigned short aread (void * ptr, unsigned short size, unsigned short n, ARCH * arch) {
	unsigned short buffsize;
	unsigned short retval;
	unsigned short maxbuffsize = arch->set + arch->size - arch->apos;
	
	if ((size * n) <= maxbuffsize) {
		buffsize = size * n;
		retval = n;
	} else {
		buffsize = maxbuffsize;
		retval = maxbuffsize / size;
	}
	if (buffsize) {
		memcpy(ptr, arch->apos, buffsize);
		arch->apos = arch->apos + buffsize;
		return retval;
	}
	
	return 0;
}

short aseek (ARCH * arch, unsigned short offset, short whence) {
	char * newpos;
	
	switch (whence) {
		case SEEK_SET:
			newpos = arch->set + offset;
			break;
		case SEEK_CUR:
			newpos = arch->apos + offset;
			break;
		case SEEK_END:
			newpos = arch->set + arch->size + offset;
			break;
		default: return 1;
	}
	if ((newpos >= arch->set) && (newpos < (arch->set + arch->size)))
		arch->apos = newpos;
	else
		return 1;
	return 0;
}
