// C Header File
// Created 07/07/2004; 18:00:07

// Cos and Sin
#define NBDIR 128 // num of dir available for rotation (must be a power of 2 <= 256)
#define SINCOS 4 // precision of cos and sin calculus (the higher the less coords you can see on the map)
// 2^SINCOS must be less or equals to : 2^15 / ((the max size of the longest side of the map (ex:45)) * (height of tiles) * 2^ZOOM)
// SINCOS must be <= 7

// Maps
#define ENABLE_LARGE_MAPS 2 // 0: disabled , 1: enabled, 2: ultra large maps with less memory use
#if ENABLE_LARGE_MAPS == 2
	#define TILES_SIZE 16 // Size in pixels of the side of the tiles used for maps
	#define TILES_SHIFT 4 // 2^TILES_SHIFT = TILES_SIZE
	#define FORCE_MAP_WITDH_TO_1024 1 // 0 : uses variable width, 1 : force to 1024
	#if FORCE_MAP_WITDH_TO_1024 == 1
		#define FILL_WITH 63 // tile number in road tiles file
	#endif
#endif

// Sprites
#define ENABLE_SPRITES 1 // 0: disabled , 1: enabled
#define ENABLE_FIRST_PLANE_SPRITES 1 // 0: disabled , 1: enabled
#define NBSPRT 10 // max number of sprite files loaded into memory
#define MAXSPRT 10 // max number of sprites
#define FRONT_CLIP_DIST 300 // max distance where you can see the sprite
#define BACK_CLIP_DIST 15 // max distance back
#define CLIP_UP 26 // up bound for drawing the sprite (value included)
#define CLIP_DOWN 100 // down bound for drawing the sprite (value not included)
#define CLIP_LEFT 0 // left bound for drawing the sprite (8 pix step)
#define CLIP_RIGHT 20 // right bound for drawing the sprite (8 pix step)
#define HORZ_MARGE 16 // horizontal marge for clipping the projected objects
#define VERT_MARGE 20 // vertical marge for clipping the projected objects

// View
#define ZOOM 1	// map zoom = 2^ZOOM (Must be positive)

// Display
#define ENABLE_MORE_DISPLAY 1 // 0: disabled , 1: enabled, launches the function initialized with m7_InitMoreDisplay just before the real display 

// Screen
#define SIZE_X 80	// horizontal resolution (SIZE_X * ZOOM_SCR_HORZ must be a multiple of 16)
#define SIZE_Y 25	// vertical resolution
#define ZOOM_SCR_HORZ 2	// horizontal zoom 1,2,4 ou 8
#define ZOOM_SCR_VERT 2	// vertical zoom
#define OFFSET_SCR_HORZ 0 // horizontal offset (8 pixels step)
#define OFFSET_SCR_VERT 50 // vertical offset

// Sky
#define ENABLE_SKY 1 // 0: disabled , 1: enabled
#define SIZE_SKY_X 80 // witdh of the picture (8 pixels step)
#define SIZE_SKY_Y 24 // height of the picture
#define SIZE_SKY_HORZ	20	// displayed horizontal size (8 pixels step)
#define OFFSET_SKY_HORZ	0	// horizontal offset (8 pixels step)
#define OFFSET_SKY_VERT 26 // vertical offset
#define NBDIVSCROLL 3 // number of division in the sky scrolling = 2^NBDIVSCROLL
#define SCROLL 5 // value of scrolling for 1 unit of direction

// Memory Management
#define DEV_PHASE 0 // 0: not in development phase, 1: get message if there is not enough *_MAX_*
#define INTERRUPT_MAX_HANDLERS 5
#define MEMORY_MAX_HANDLES 32
#define MEMORY_MSG "There is not enough free RAM. Please archive every file and uninstall FlashApps if necessary. F-ZERO needs approximately all the 200k RAM"

// misc
#define GAME_SPEED 10 // 0: the fastest
#define ENABLE_GRAYSCALE 1 // 0: disabled , 1: enabled, mode7 in 4 grayscale
#define ENABLE_ROTATION 1 // 0: disabled , 1: enabled, 2: uses precalculated tables

// debug
#define SHOW_FPS 0 // 0: do not show, 1: show
