// C Source File
// Created 13/02/2005; 10:23:25

#include "Mode7Engine.h"

unsigned char linkenabled;
unsigned char linkmode; // 0: slave, 1: master
unsigned char linktype;
unsigned char send, recv;
volatile unsigned char received;
volatile unsigned short timeout;
void (*m7Link_FillSend)(void);
char (*m7Link_Break)(void);

void m7Link_SetFunc(void (*FillSend)(void)) {
	m7Link_FillSend = FillSend;
}

void m7Link_SetBreakFunc(char (*Break)(void)) {
	m7Link_Break = Break;
}

void m7Link_Flush(void) {
	char c;
	while(OSReadLinkBlock (&c, 1));
}

char m7Link_Connect(void) {
	char c;	
	timeout = 0;
	
	if(linkmode) {
		while(!OSReadLinkBlock (&c, 1)) if(m7Link_Break()) return 0;
		OSWriteLinkBlock (&linkmode, 1);
		received = 2;
	}
	else {
		OSWriteLinkBlock (&linkmode, 1);
		while(!OSReadLinkBlock (&c, 1)) if(m7Link_Break()) return 0;
		received = 0;
	}

	if(c == linkmode) return 0; // failure : both master or both slave
	return 1;
}

void timeIncr(void) {
	if(++timeout == TIMEOUT) m7_LoopEnd();
}

void masterModif(void) {
	if(received) {
		m7Link_FillSend();
		OSWriteLinkBlock (&send, 1);
		received = 0;
	}
}

void slaveModif(void) {
	m7Link_FillSend();
	OSWriteLinkBlock (&send, 1);
}

void LinkRecv(void) {
	if(OSReadLinkBlock (&recv, 1)) {
		timeout = 0;
		received = 1;
	}
}

