// C Source File
// Created 13/03/2004; 10:19:46

#include "Mode7Engine.h"

Map * map_Load(ARCH * archmap, ARCH * archtile, const char * mapFileName, const char * tilesFileName) {
	Map * map;
	unsigned long i,j;
	ARCH * tilesFile;
	ARCH * mapFile;
	unsigned short nbTiles, Width, Height;
	unsigned long lWidth, lHeight;
	unsigned char * tmp;

	map = (Map *)Malloc(sizeof(Map));

	tilesFile = aopen(archtile, tilesFileName);
	mapFile = aopen(archmap, mapFileName);

	aread (&(map->dimX), sizeof(short), 1, mapFile); 
	aread (&(map->dimY), sizeof(short), 1, mapFile); 
	aseek (tilesFile, 2, SEEK_SET);
	aread (&nbTiles, sizeof(short), 1, tilesFile);
	aread (&Width, sizeof(short), 1, tilesFile);
	aread (&Height, sizeof(short), 1, tilesFile);
	lWidth = (long)Width;
	lHeight = (long)Height;

	map->map = mapFile->apos;

	map->map0 = (unsigned char *)Malloc(sizeof(unsigned char) * map->dimX * map->dimY * lWidth * lHeight);
#if ENABLE_GRAYSCALE == 1
	map->map1 = (unsigned char *)Malloc(sizeof(unsigned char) * map->dimX * map->dimY * lWidth * lHeight);
#endif

	for(i=0;i < ((map->dimX) * (map->dimY));i++) {

#if ENABLE_GRAYSCALE == 1
		aseek (tilesFile, 8 + (map->map[i]) * lWidth * lHeight * 2, SEEK_SET);
#else
		aseek (tilesFile, 8 + (map->map[i]) * lWidth * lHeight, SEEK_SET);
#endif


		tmp = tilesFile->apos;

		for(j=0; j<lHeight; j++) {
			memcpy(&(map->map0[((i * lWidth) % (map->dimX * lWidth)) + (map->dimX * lWidth * lHeight) * ((i * lWidth)/(map->dimX * lWidth)) + (j * (map->dimX * lWidth))]), &(tmp[j * lWidth]), lWidth);
		}
#if ENABLE_GRAYSCALE == 1
		tmp += lWidth * lHeight;

		for(j=0; j<lHeight; j++) {
			memcpy(&(map->map1[((i * lWidth) % (map->dimX * lWidth)) + (map->dimX * lWidth * lHeight) * ((i * lWidth)/(map->dimX * lWidth)) + (j * (map->dimX * lWidth))]), &(tmp[j * lWidth]), lWidth);
		}
#endif

	}

	aclose(tilesFile);
	aclose(mapFile);

	map->dimY *= lHeight;
	map->dimX *= lHeight;

	return map;
}

void map_Free(Map * map) {
	Free(map->map0);
#if ENABLE_GRAYSCALE == 1
	Free(map->map1);
#endif
	Free(map);
}


#if ENABLE_LARGE_MAPS == 2


ExtraMap * map_XMapLoad(ARCH * roadpk, ARCH * offroadpk, ARCH * maparch,
												const char * roadfile, const char * offroadfile,
												const char * roadmfile, const char * offroadmfile,
												unsigned short selectionoffset,
												const char * mapFileName
#if FORCE_MAP_WITDH_TO_1024 == 1
												, unsigned short fillwith
#endif
												) {

	unsigned short i;
	unsigned char tilenum;
	ExtraMap * map;
	ARCH * arch, * arch2, * arch3, * arch4;
	unsigned short nbTiles;
#if FORCE_MAP_WITDH_TO_1024 == 1
	unsigned char * filltile;
	unsigned short j;
#endif

#if ENABLE_GRAYSCALE == 1
	#define TILES_OFFSET (TILES_SIZE * TILES_SIZE * 2)
#else
	#define TILES_OFFSET (TILES_SIZE * TILES_SIZE)
#endif

	map = (ExtraMap *)Malloc(sizeof(ExtraMap));

	arch = aopen(maparch, mapFileName);
#if ENABLE_COMPRESSED_MAPS == 1
	map->map = uncompress(arch->apos, &i);
	map->dimX = *(((unsigned short *)map->map)++);
	map->dimY = *(((unsigned short *)map->map)++);
#else
	aread (&(map->dimX), sizeof(short), 1, arch);
	aread (&(map->dimY), sizeof(short), 1, arch);
	map->map = arch->apos;
#endif
	aclose(arch);

	arch  = aopen(roadpk, roadfile);
	arch2 = aopen(offroadpk, offroadfile);
	arch3 = aopen(roadpk, roadmfile);
	arch4 = aopen(offroadpk, offroadmfile);

	aseek (arch, 2, SEEK_SET);
	aread (&nbTiles, sizeof(short), 1, arch);

#if FORCE_MAP_WITDH_TO_1024 == 1
	map->maptiles = (unsigned char **)Malloc(map->dimY * (1 << (10-TILES_SHIFT)) * sizeof(unsigned char *));
	map->mask = (unsigned char **)Malloc(map->dimY * (1 << (10-TILES_SHIFT)) * sizeof(unsigned char *));
	aseek (arch2, 8 + (fillwith + selectionoffset) * TILES_OFFSET, SEEK_SET);
	filltile = arch2->apos;
#else
	map->maptiles = (unsigned char **)Malloc(sizeof(unsigned char *) * map->dimX * map->dimY);
	map->mask = (unsigned char **)Malloc(map->dimY * (1 << (10-TILES_SHIFT)) * sizeof(unsigned char *));
#endif
	
	aseek (arch4, 8, SEEK_SET);

#if FORCE_MAP_WITDH_TO_1024 == 1
	for(i=0;i < (1 << (10-TILES_SHIFT));i++) {
		for(j=0;j < (map->dimY);j++) {
			if(i < (map->dimX)) {
				if ((tilenum = map->map[i + (j * (map->dimX))]) < nbTiles) {
					aseek (arch, 8 + tilenum * TILES_OFFSET, SEEK_SET);
					aseek (arch3, 8 + tilenum * (TILES_OFFSET>>1), SEEK_SET);
					map->maptiles[i + (j * (1 << (10-TILES_SHIFT)))] = arch->apos;
					map->mask[i + (j * (1 << (10-TILES_SHIFT)))] = arch3->apos;
				} else {
					aseek (arch2, 8 + (tilenum - nbTiles + selectionoffset) * TILES_OFFSET, SEEK_SET);
					map->maptiles[i + (j * (1 << (10-TILES_SHIFT)))] = arch2->apos;
					map->mask[i + (j * (1 << (10-TILES_SHIFT)))] = NULL;//arch4->apos;
				}
			} else {
				map->maptiles[i + (j * (1 << (10-TILES_SHIFT)))] = filltile;
				map->mask[i + (j * (1 << (10-TILES_SHIFT)))] = arch4->apos;
			}
		}
	}
#else
	for(i=0;i < ((map->dimX) * (map->dimY));i++) {
		if ((tilenum = map->map[i]) < nbTiles) {
			aseek (arch, 8 + tilenum * TILES_OFFSET, SEEK_SET);
			aseek (arch3, 8 + tilenum * TILES_OFFSET, SEEK_SET);
			map->maptiles[i] = arch->apos;
			map->mask[i] = arch3->apos;
		} else {
			aseek (arch2, 8 + (tilenum - nbTiles + selectionoffset) * TILES_OFFSET, SEEK_SET);
			map->maptiles[i] = arch2->apos;
			map->mask[i] = arch4->apos;
		}
	}
#endif
	aclose(arch);
	aclose(arch2);
	aclose(arch3);
	aclose(arch4);

	return map;

}


void map_XMapFree(ExtraMap * map) {
#if ENABLE_COMPRESSED_MAPS == 1
	Free((map->map - 4));
#endif
	Free(map->maptiles);
	Free(map->mask);
	Free(map);
}

#endif
