// C Source File
// Created 02/01/2005; 23:14:39

#include "Mode7Engine.h"

#if DEV_PHASE == 1
unsigned char overhdl = 0;
unsigned char overint = 0;
#endif
#if AUTO_INT_5_GRAYSCALE == 1
extern unsigned char AI5start;
extern unsigned short AI5rate;
#endif

void (*ExitFunc)(void) = NULL;
INT_HANDLER hdlrs[INTERRUPT_MAX_HANDLERS*2];
HANDLE hdls[MEMORY_MAX_HANDLES];
unsigned short nbhdl = 0;
unsigned short nbhdlr = 0;

#if AUTO_INT_5_GRAYSCALE == 1
void InitExit (void) {
	AI5rate = PRG_getRate(); 
	AI5start = PRG_getStart();
}
#endif

void SetExitFunc (void (*exitFunc)(void)) {
	ExitFunc = exitFunc;
}

__attribute__((noreturn)) void Exit (unsigned char msg) {
	HANDLE * hdl = hdls + nbhdl;
	for(; (hdl--) != hdls; HeapFree(*hdl));
	GrayOff ();
	INT_HANDLER* hdlr = hdlrs + 2*nbhdlr;
	for(; hdlr != hdlrs; hdlr-=2 ,SetIntVec ((long)(*hdlr), *(hdlr+1)));
	ClrScr ();
#if DEV_PHASE == 1
	char str[59];
	if(overhdl) DlgMessage("DEVELOPMENT","Not enough MEMORY_MAX_HANDLES",BT_OK,BT_NONE);
	else if(overint) DlgMessage("DEVELOPMENT","Not enough INTERRUPT_MAX_HANDLERS",BT_OK,BT_NONE);
	else if(!msg && nbhdl > NB_EXIT_HANDLES) {
		sprintf(str, "Memory Leak Detected : %u abnormally not freed Handles", nbhdl-NB_EXIT_HANDLES);
		DlgMessage("DEVELOPMENT",str,BT_OK,BT_NONE);
	}
#endif
	if(msg) DlgMessage("MEMORY",MEMORY_MSG,BT_OK,BT_NONE);
	nbhdl=0;
	nbhdlr = 0;
#if AUTO_INT_5_GRAYSCALE == 1
	PRG_setRate (AI5rate); 
	PRG_setStart(AI5start);
#endif
	if(ExitFunc) ExitFunc();
	exit (0);	
}

static inline void *MallocInternal (unsigned long Size, unsigned char exit_if_fail) {
#if DEV_PHASE == 1
	if(nbhdl == MEMORY_MAX_HANDLES) overhdl = 1, Exit (0);
#endif
	HANDLE * hdl = hdls + (nbhdl++);
	if ((*hdl = HeapAlloc(Size)))
		return HLock(*hdl);
	nbhdl--;
	if (exit_if_fail) Exit (1);
	return NULL;
}

void *Malloc (unsigned long Size) {
	return MallocInternal(Size, 1);
}

void *MallocNoExit (unsigned long Size) {
	return MallocInternal(Size, 0);
}

void *Realloc (void *Ptr, unsigned long NewSize) {
	HANDLE h;
	if ((h = HeapRealloc(HeapUnlock(HeapPtrToHandle(Ptr)), NewSize)))
		return HLock(h);
	Exit (1);
}

static inline HANDLE FreeInternal (void *Ptr, unsigned char keep) {
	HANDLE * hdl = hdls + nbhdl - 1;
	HANDLE h = H_NULL;
	unsigned char i = 0;
	for(; HeapDeref(*hdl) != Ptr; hdl--, i++);
	if(!keep) HeapFree(*hdl);
	else h = *hdl;
	memmove (hdl, hdl+1, i * sizeof(HANDLE));
	nbhdl--;
	return h;
}

void Free (void *Ptr) {
	FreeInternal(Ptr, 0);
}

HANDLE Keep (void *Ptr) {
	return FreeInternal(Ptr, 1);
}

INT_HANDLER SetIntVector(long IntVec, INT_HANDLER Handler) {
#if DEV_PHASE == 1
	if(nbhdlr == INTERRUPT_MAX_HANDLERS) overint = 1, Exit (0);
#endif
	INT_HANDLER* hdlr = hdlrs + 2*(nbhdlr++);
	*(hdlr++) = (INT_HANDLER)IntVec;
	*hdlr = GetIntVec (IntVec);
	SetIntVec (IntVec, Handler);
	return (*hdlr);
}

void ReSetIntVector(long IntVec) {
	INT_HANDLER* hdlr = hdlrs + 2*(nbhdlr - 1);
	unsigned char i = 0;	
	for(; (long)(*hdlr) != IntVec; hdlr-=2, i++);
	SetIntVec (IntVec, *(hdlr+1));
	memmove (hdlr, hdlr+2, i * sizeof(INT_HANDLER)*2);
	nbhdlr--;
}
